%if 0

Extensions for lDebug linker

Copyright (C) 2008-2023 C. Masloch

Usage of the works is permitted provided that this
instrument is retained with the works, so that any entity
that uses the works is notified of this instrument.

DISCLAIMER: THE WORKS ARE WITHOUT WARRANTY.

%endif

%include "lmacros3.mac"
%include "eld.mac"

	eldcall_dump_callcall ELDCALL_CALLCALL_LIST
%unimacro extcallcall 1.nolist

endresident: equ ($ + _CURRENT_SECTION %+ FIXUP + 15) & ~15


linker:
	lframe
	lenter
	lvar dword, instance
	 push es
	 push dx
	xor ax, ax
	cmp word [di], 0E1D0h
	jne .error
	cmp word [di + 6], 1
	ja .error
	jb @F
	dec ax
@@:
	lvar word, use_hash
	 push ax
	lvar dword, linkinfo
	 push ds
	 push di
	lvar dword, nextreloc
	 push es
	 push dx
	lvar dword, entry
	 push es
	 push ax		; placeholder
	push si
	push bx

			; simple: add instance base (dx)
	push es
	pop ds
	mov si, internalcoderelocations
	add si, dx
@@:
	lodsw
	test ax, ax		; was last ?
	jz @F			; yes -->
	xchg bx, ax		; bx = entry
	add bx, dx		; relocate the entry itself
	add word [bx], dx	; relocate word referenced by entry
	jmp @B

@@:
			; next, add heap data base (on stack)
	mov si, internaldatarelocations
	add si, dx
@@:
	lodsw
	test ax, ax		; was last ?
	jz @F			; yes -->
	xchg bx, ax		; bx = entry
	add bx, dx		; relocate the entry itself
	pop ax			; ax -> heap data
	push ax
	sub ax, datastart	; undo adjustment
	add word [bx], ax	; relocate word referenced by entry
	jmp @B

@@:
	mov dx, word [bp + ?instance]
	add dx, linkerdatarelocations
	mov word [bp + ?nextreloc], dx

.datarelocloop:		; must be done before further relocs
	lds si, [bp + ?nextreloc]
	lodsw
	add ax, word [bp + ?instance]
	mov word [bp + ?entry], ax
	lodsw
	mov word [bp + ?nextreloc], si
	test ax, ax
	jz .donedatareloc
	call .build_match
	les bx, [bp + ?linkinfo]
	mov cx, word [es:bx + 8]	; amount data link info
	mov di, word [es:bx + 10]	; -> prefixes or hashes
.datarelocfind:
	repne scasw			; scan initial
	jne .error
	push di
	push cx
	push si
	sub di, word [es:bx + 10]	; = double index, 1-based
	dec di
	dec di				; 0-based
	add di, word [es:bx + 12]	; -> entry
	mov di, [es:di]			; -> counted suffix/string
	mov ch, 0
	mov cl, byte [si]		; cx = length
	inc cx
	; cmp al, al			; ZR if length is zero
	repe cmpsb			; match ?
	pop si
	pop cx
	pop di
	jne .datarelocfind
	sub di, word [es:bx + 10]	; = double index, 1-based
	dec di
	dec di				; 0-based
	add di, word [es:bx + 14]	; -> address (offset)
	mov ax, word [es:di]
	lds si, [bp + ?entry]
	sub ax, relocateddata		; *not* a relocation
	add word [si], ax		; relocate
	jmp .datarelocloop


.build_match:
	mov si, ax
	add si, word [bp + ?instance]
	lodsw			; = hash, si -> counted string
	rol byte [bp + ?use_hash], 1
	jc @F
	lodsb
	xchg cx, ax		; cl = length
	lodsw			; ax = prefix
	dec cx
	dec cx
	dec si
	mov byte [si], cl	; si -> counted string suffix
@@:
	retn


.donedatareloc:
	mov dx, word [bp + ?instance]
	add dx, linkercoderelocations
	mov word [bp + ?nextreloc], dx

.coderelocloop:
	lds si, [bp + ?nextreloc]
	lodsw
	add ax, word [bp + ?instance]
	mov word [bp + ?entry], ax
	lodsw
	mov word [bp + ?nextreloc], si
	test ax, ax
	jz .donecodereloc
	call .build_match
	les bx, [bp + ?linkinfo]
	mov cx, word [es:bx + 16]	; amount code link info
	mov di, word [es:bx + 18]	; -> prefixes or hashes
.coderelocfind:
	repne scasw			; scan initial
	jne .error
	push di
	push cx
	push si
	sub di, word [es:bx + 18]	; = double index, 1-based
	dec di
	dec di				; 0-based
	add di, word [es:bx + 20]	; -> entry
	mov di, [es:di]			; -> counted suffix/string
	mov ch, 0
	mov cl, byte [si]		; cx = length
	inc cx
	; cmp al, al			; ZR if length is zero
	repe cmpsb			; match ?
	pop si
	pop cx
	pop di
	jne .coderelocfind
	sub di, word [es:bx + 18]	; = double index, 1-based
	dec di
	dec di				; 0-based
	add di, di			; quadruple index
	add di, word [es:bx + 22]	; -> address (offset, segment)
	push word [es:di]
	lds si, [bp + ?entry]
	pop word [si + 3 + 2]		; call near imm (3), jmp short (2)
					;  patch the destination address
	cmp byte [si], 0E8h		; is it as expected ?
	jne .error
	mov di, word [es:di + 2]
	mov bx, relocateddata
linkdatarelocation linkcall_table	; ss:bx -> link call table
	cmp word [ss:bx], 1		; is it initialised to format 1 ?
	jne .error			; no -->
	mov cx, word [ss:bx + 2]	; get amount of segments
	jcxz .error			; none -->
@@:
	add bx, 4			; -> next segment
	cmp word [ss:bx], di		; value matches ?
	je @F				; yes, found -->
	loop @B				; try remaining segments
	jmp .error

@@:
	mov bx, word [ss:bx + 2]	; -> call destination offset
		; si + 3 + delta = bx
		; delta = bx - si - 3
	sub bx, si
	sub bx, 3
	mov word [si + 1], bx		; patch the call instruction
	jmp .coderelocloop

.donecodereloc:
	pop bx				; -> our heap data
	pop si				; -> our command line tail
	 push ss
	 pop ds
	les di, [bp + ?instance]
	mov ax, word [es:di + eldiEndCode]
	sub ax, strict word endresident
internalcoderelocation
	mov word [es:di + eldiEndCode], endresident
internalcoderelocation
	sub word [relocateddata], ax
linkdatarelocation extseg_used
%if _DATA_SIZE == 0
	xor ax, ax
	mov word [es:di + eldiStartData], ax
	mov word [es:di + eldiEndData], ax
%endif
	lleave code
	jmp start

.error:
	les di, [bp + ?instance]
	mov byte [es:di + eldiIdentifier], 0
	lleave
	mov ax, -1
	retf


	align 4, db 0
linkercoderelocations:
	dw ELDCALL_CODE_RELOCATIONS, 0, 0

	align 4, db 0
linkerdatarelocations:
	dw LINK_DATA_RELOCATIONS, 0, 0

	align 2, db 0
internalcoderelocations:
	dw INTERNAL_CODE_RELOCATIONS, 0

	align 2, db 0
internaldatarelocations:
	dw INTERNAL_DATA_RELOCATIONS, 0

	eldcall_dump_names ELDCALL_CODE_NAMES
	link_data_dump_names LINK_DATA_NAMES

	align 16, db 0
